#include <acknex.h>
#include <default.c>
#include <particles.c>

var boxw=30;
var boxh=30;

typedef struct
{
	int id;
	var px;
	var py;
	STRING* letter;
	PANEL* panel;
}holder;

holder* letter_array;
holder* message_compare;
STRING* clue[256];
STRING* answer[256];

int score=0;
int current_question=1;
int total_questions=21;

int total_letters;
int selected_box=0;
int let_arr[256][256];
int letc_arr[256];
int cnt;
int check_timeout=0;
int total_correct=0;
PANEL* boxinner[256];

PANEL* back=
{
	bmap="logo_800.jpg";
	layer=-1;
	flags=SHOW;
}

function add_letterbox(var px,var py,int id)
{
	BMAP *inside="box.bmp";
	boxinner[id]=pan_create(NULL,99);
	
	boxinner[id].bmap=inside;
	boxinner[id].pos_x=px;
	boxinner[id].pos_y=py;

	letter_array[id].panel=boxinner[id];
	set(letter_array[id].panel,SHOW);

	letter_array[id].px=px;
	letter_array[id].py=py;
}

//encoded shift(amount of ascii increase/decrease,increase=1 decrease=0)
//encodes answer by shifting x amount of ascii codes
void encode_shift(int index)//int amount,int do_inc,int index)
{
	int i;
	int alphabet[25];
	for(i=0;i<25;i++)	alphabet[i]=i+97;
	
	for(i=1;i<total_letters+1;i++)
	{
		char c=str_getchr(answer[index],i);
		STRING* temp=str_create("");
		if(c!=32)
		{
			if(c==95)str_printf(temp,"%c",c);
			else
			{
				//str_printf(temp,"%c",alphabet[integer(random(25))]);
				str_printf(temp,"a");
				//if(do_inc==1)str_printf(temp,"%c",c+amount);
				//if(do_inc==0)str_printf(temp,"%c",c-amount);
			}
		}
		letter_array[i-1].letter=temp;
	}
}

//restores non encoded answer
void decode(int index)
{
	int i;
	for(i=1;i<total_letters+1;i++)
	{
		char c=str_getchr(answer[index],i);
		STRING* temp=str_create("");
		str_printf(temp,"%c",c);
		letter_array[i-1].letter=temp;
	}
}

void select_box(int id)
{
	BMAP* bc="boxg.bmp";
	BMAP* bd="boxr.bmp";
	if(id==selected_box)letter_array[id].panel.bmap=bc;
	else
	letter_array[id].panel.bmap=bd;
}

void deselect_box(int id)
{
	BMAP* bn="box.bmp";
	letter_array[id].panel.bmap=bn;
}

void init_all_boxes_of(char trg)
{
	int i;
	cnt=0;
	for(i=0;i<total_letters;i++)
	{
		char cs=str_getchr(letter_array[i].letter,1);
		char t=str_getchr(trg,1);
		if(cs==t)
		{
			let_arr[t][cnt]=i;
			cnt+=1;
			letc_arr[t]=cnt;
		}
	}

}

function snow()
{
	proc_kill(4);	// terminate previous snow functions

	VECTOR wind_speed;
	vec_set(wind_speed,vector(0,0,0));
	while(1)
	{
		effect(p_snow,40*time_frame,nullvector,vector(0,0,-1));
		wait(1);
	}
}

void init_question(int index)
{
	int i;
	for(i=0;i<total_letters;i++)
	{
		char c=str_getchr(message_compare[i].letter,1);
		SOUND* aa="a.ogg";
		SOUND* bb="b.ogg";
		SOUND* cc="c.ogg";
		SOUND* dd="d.ogg";
		SOUND* ee="e.ogg";
		SOUND* ff="f.ogg";
		SOUND* gg="g.ogg";
		SOUND* hh="h.ogg";
		SOUND* ii="i.ogg";
		SOUND* jj="j.ogg";
		SOUND* kk="k.ogg";
		SOUND* ll="l.ogg";
		SOUND* mm="m.ogg";
		SOUND* nn="n.ogg";
		SOUND* oo="o.ogg";
		SOUND* pp="p.ogg";
		SOUND* qq="q.ogg";
		SOUND* rr="r.ogg";
		SOUND* ss="s.ogg";
		SOUND* tt="t.ogg";
		SOUND* uu="u.ogg";
		SOUND* vv="v.ogg";
		SOUND* ww="w.ogg";
		SOUND* xx="x.ogg";
		SOUND* yy="y.ogg";
		SOUND* zz="z.ogg";
		if(c=='a')snd_play(aa,100,0);
		if(c=='b')snd_play(bb,100,0);
		if(c=='c')snd_play(cc,100,0);
		if(c=='d')snd_play(dd,100,0);
		if(c=='e')snd_play(ee,100,0);
		if(c=='f')snd_play(ff,100,0);
		if(c=='g')snd_play(gg,100,0);
		if(c=='h')snd_play(hh,100,0);
		if(c=='i')snd_play(ii,100,0);
		if(c=='j')snd_play(jj,100,0);
		if(c=='k')snd_play(kk,100,0);
		if(c=='l')snd_play(ll,100,0);
		if(c=='m')snd_play(mm,100,0);
		if(c=='n')snd_play(nn,100,0);
		if(c=='o')snd_play(oo,100,0);
		if(c=='p')snd_play(pp,100,0);
		if(c=='q')snd_play(qq,100,0);
		if(c=='r')snd_play(rr,100,0);
		if(c=='s')snd_play(ss,100,0);
		if(c=='t')snd_play(tt,100,0);
		if(c=='u')snd_play(uu,100,0);
		if(c=='v')snd_play(vv,100,0);
		if(c=='w')snd_play(ww,100,0);
		if(c=='x')snd_play(xx,100,0);
		if(c=='y')snd_play(yy,100,0);
		if(c=='z')snd_play(zz,100,0);
		deselect_box(i);
		ptr_remove(boxinner[i]);
		score+=1;
		wait(2);
	}
	
	for(i=0;i<256;i++)
	{
		let_arr[i][i]=0;
		letc_arr[i]=0;
	}
	//ptr_remove(letter_array);
	//ptr_remove(message_compare);
	//memset(letter_array,0,sizeof(int));
	//memset(message_compare,0,sizeof(int));

	total_correct=0;
	cnt=0;
	
	selected_box=0;
	total_letters=0;
	answer[index]=str_create("");
	clue[index]=str_create("");

	switch (index)
	{
		case 1:
		{
			str_printf(clue[index],"A pixel's opacity in percent (0..100).",NULL);
 			str_printf(answer[index],"alpha",NULL);
		}
		case 2:
		{
			str_printf(clue[index],"Opacity of an image defined by an alpha value per each pixel",NULL);
 			str_printf(answer[index],"alpha channel",NULL);
		}
		case 3:
		{
			str_printf(clue[index],"Light and material property that illuminates all parts of an object equally,\nregardless of their orientation, position, and surface characteristics.",NULL);
 			str_printf(answer[index],"ambient",NULL);
		}
		case 4:
		{
			str_printf(clue[index],"Mipmap filtering mode that compensates for anisotropic distortion.",NULL);
 			str_printf(answer[index],"anisotropic filtering",NULL);
		}
		case 5:
		{
			str_printf(clue[index],"A sequence of frames withing a model",NULL);
 			str_printf(answer[index],"animation",NULL);
		}
		case 6:
		{
			str_printf(clue[index],"Group of elements organized into an array",NULL);
 			str_printf(answer[index],"array",NULL);
		}
		case 7:
		{
			str_printf(clue[index],"Connecting multiple objects to each other, for instance a weapon to an actor",NULL);
 			str_printf(answer[index],"attach",NULL);
		}
		case 8:
		{
			str_printf(clue[index],"Nonvisible surface onto which the renderer draws the next image\nwhile the front buffer displays the currently visible image.",NULL);
 			str_printf(answer[index],"back buffer",NULL);
		}
		case 9:
		{
			str_printf(clue[index],"Non-oriented sprite that is oriented so that it faces the viewer",NULL);
 			str_printf(answer[index],"billboard",NULL);
		}
		case 10:
		{
			str_printf(clue[index],"A box around a model",NULL);
 			str_printf(answer[index],"bounding box",NULL);
		}
		case 11:
		{
			str_printf(clue[index],"Technique for simulating the appearance of rough surfaces in 3-D scenes",NULL);
 			str_printf(answer[index],"bump mapping",NULL);
		}
		case 12:
		{
			str_printf(clue[index],"Process for determining whether objects collide",NULL);
 			str_printf(answer[index],"collision detection",NULL);
		}
		case 13:
		{
			str_printf(clue[index],"An animation frame containing all the data needed to render\na model without reference to previous frames.",NULL);
 			str_printf(answer[index],"key frame",NULL);
		}
		case 14:
		{
			str_printf(clue[index],"a delay in response",NULL);
 			str_printf(answer[index],"latency",NULL);
		}
		case 15:
		{
			str_printf(clue[index],"a texture or group of textures that contain\nlighting information for a 3-D scene.",NULL);
 			str_printf(answer[index],"light map",NULL);
		}
		case 16:
		{
			str_printf(clue[index],"Copies the second vector to the first,\nthus overwriting the first vector.",NULL);
 			str_printf(answer[index],"vec_set",NULL);
		}
		case 17:
		{
			str_printf(clue[index],"Scales a vector to a magnitude while keeping it's direction",NULL);
 			str_printf(answer[index],"vec_normalize",NULL);
		}
		case 18:
		{
			str_printf(clue[index],"Appends a copy of string2 to the end of string1",NULL);
 			str_printf(answer[index],"str_cat",NULL);
		}
		case 19:
		{
			str_printf(clue[index],"Opens a file for reading.",NULL);
 			str_printf(answer[index],"file_open_read",NULL);
		}
		case 20:
		{
			str_printf(clue[index],"Removes a level, view, or sky entity.",NULL);
 			str_printf(answer[index],"ent_remove",NULL);
		}
		case 17:
		{
			str_printf(clue[index],"Returns the distance between two positions.",NULL);
 			str_printf(answer[index],"vec_dist",NULL);
		}
		case 18:
		{
			str_printf(clue[index],"Creates a variable length STRING object at runtime",NULL);
 			str_printf(answer[index],"str_create",NULL);
		}
		case 19:
		{
			str_printf(clue[index],"Returns the type of the entity, or the type of the current level.",NULL);
 			str_printf(answer[index],"ent_type",NULL);
		}
		case 20:
		{
			str_printf(clue[index],"Calculates the current Euler angle of a bone",NULL);
 			str_printf(answer[index],"ang_for_bone",NULL);
		}
		case 21:
		{
			str_printf(clue[index],"thats all for this demo...",NULL);
 			str_printf(answer[index],"have a nice day johan bender ...thank you for playing this demo",NULL);
 			wait(-2);
		}
	}
//lower case
	answer[index]=str_lwr(answer[index]);
	
	total_letters=str_len(answer[index]);
	letter_array=malloc(sizeof(holder)*total_letters);
	message_compare=malloc(sizeof(holder)*total_letters);

//create letterboxes
	int px=40;
	int py=80;
	int boxesy=1;

	for(i=1;i<total_letters+1;i++)
	{
		char c=str_getchr(answer[index],i);
		STRING* temp=str_create("");
		str_printf(temp,"%c",c);
		message_compare[i-1].letter=temp;
		letter_array[i-1].letter=temp;
		letter_array[i-1].id=i-1;
		add_letterbox(px,py,i-1);
		px+=boxw;
		
		if(px>650)
		{
			px=40;
			py+=boxh;
			boxesy+=1;
		}
	}
////////


//init all doubles
	STRING* doubled=NULL;
	for(i=0;i<256;i++)
	{
		doubled=str_create("");
		str_printf(doubled,"%c",i);
		char ch=str_getchr(doubled,1);
		init_all_boxes_of(ch);
	}

	//encode answer	
//	random_seed(0);
//	int amount=integer(random(5));
//	if(amount<1)amount=1;
	//encode_shift(amount,random(1),index);
	if(current_question!=total_questions)encode_shift(index);
	//decode answer
	//decode(index);
}

void check()
{
	total_correct=0;
	int i;
	for(i=0;i<total_letters;i++)
	{
		char c=str_getchr(message_compare[i].letter,1);
		STRING* num1=str_create("");
		str_printf(num1,"%c",c);

		char ch=str_getchr(letter_array[i].letter,1);
		STRING* num2=str_create("");
		if(c==32)str_printf(num2," ");
		else str_printf(num2,"%c",ch);
		if(str_cmpi(num1,num2))// && c!=32 && ch!=32)
		{
			total_correct+=1;
		}
	}
	if(total_correct==total_letters)
	{
		if(current_question!=total_questions)
		{
			current_question+=1;
			init_question(current_question);
		}		
		if(current_question==total_questions)
		{
			wait(1);
		}
	}
}

void main()
{
	fps_max=60;	
	fps_min=60;	
	
 	level_load(NULL);
	vec_set(screen_color,vector(1,1,1));
	vec_set(sky_color,vector(0,0,0));
	//video_mode=8;

	int i;
	var keydr=0;
	var keydl=0;
	var keydu=0;
	var keydd=0;
	int count=0;
	int ncount=0;

////////////
	max_particles = 30000;
	snow();
//////////////

	current_question=1;
	init_question(current_question);
	
	while(1)
	{
		draw_text(str_printf(NULL,"lite-c gamestudio trivia system..SCORE:%d",score),0,0,vector(225,0,225));
		draw_text(clue[current_question],0,20,vector(225,225,225));
		
		draw_text(str_printf(NULL,"%d of %d letters correct",total_correct,total_letters),0,360,vector(225,225,225));
		draw_text("up/down: change letter",0,380,vector(225,225,225));
		draw_text("left/right: change position",0,400,vector(225,225,225));
		draw_text("green box: your current location",0,420,vector(225,225,225));
		draw_text("red box: a clue for duplicated letters",0,440,vector(225,225,225));

		check_timeout+=5*time_step;
		if(check_timeout>100)
		{
			check();
			check_timeout=0;
		}

		for(i=0;i<total_letters;i++)
		{
			draw_text(letter_array[i].letter,
			letter_array[i].px+boxw/4,
			letter_array[i].py+boxh/4,
			vector(225,225,225));
		}

//select similar	
		int b;
		int a;
		for(a=0;a<256;a++)
		{
			for(b=0;b<letc_arr[a];b++)
			{
				if(let_arr[a][b]==selected_box)
				{
					int t;
					for(t=0;t<letc_arr[a];t++)
					{
						select_box(let_arr[a][t]);
					}
				}
			}
		}

		if(!key_cur)keydr=0;
		if(!key_cul)keydl=0;
		if(!key_cuu)keydu=0;
		if(!key_cud)keydd=0;
		if(key_cur)
		{
			if(!keydr)
			{
				if(selected_box<total_letters-1)
				{
					for(i=0;i<total_letters;i++)
					deselect_box(i);
					selected_box+=1;
				}
				keydr=1;
			}
		}
		if(key_cul)
		{
			if(!keydl)
			{
				if(selected_box>0)
				{
					for(i=0;i<total_letters;i++)
					deselect_box(i);
					selected_box-=1;
				}
				keydl=1;
			}
		}
		if(key_cuu)
		{
			if(!keydu)
			{
				char cc=str_getchr(message_compare[selected_box].letter,1);
				char c=str_getchr(letter_array[selected_box].letter,1);
				STRING* tmp=str_create("");
				if(c>97 && c!=95 &&cc!=32)str_printf(tmp,"%c",c-1);
				else str_printf(tmp,"%c",c);
				tmp=str_lwr(tmp);

				int b;
				int a;
				for(a=0;a<256;a++)
				{
					for(b=0;b<letc_arr[a];b++)
					{
						if(let_arr[a][b]==selected_box)
						{
							int t;
							for(t=0;t<letc_arr[a];t++)
							{
								letter_array[let_arr[a][t]].letter=tmp;
							}
						}
					}
				}
			keydu=1;
			}
		}
		if(key_cud)
		{
			if(!keydd)
			{
				char cc=str_getchr(message_compare[selected_box].letter,1);
				char c=str_getchr(letter_array[selected_box].letter,1);
				STRING* tmp=str_create("");
				if(c<122 && c!=95 && cc!=32)str_printf(tmp,"%c",c+1);
				else str_printf(tmp,"%c",c);

				tmp=str_lwr(tmp);
				
				int b;
				int a;
				for(a=0;a<256;a++)
				{
					for(b=0;b<letc_arr[a];b++)
					{
						if(let_arr[a][b]==selected_box)
						{
							int t;
							for(t=0;t<letc_arr[a];t++)
							{
								letter_array[let_arr[a][t]].letter=tmp;
							}
						}
					}
			}
			keydd=1;
			}
		}
	wait(1);
	}
	sys_free(letter_array);
}